/[gentoo-x86]/eclass/gnome2.eclass
Gentoo

Diff of /eclass/gnome2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.77 Revision 1.119
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/gnome2.eclass,v 1.77 2006/12/12 02:58:22 leonardop Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/gnome2.eclass,v 1.119 2013/01/16 22:52:37 eva Exp $
4 4
5#
6# gnome2.eclass 5# @ECLASS: gnome2.eclass
7# 6# @MAINTAINER:
7# gnome@gentoo.org
8# @BLURB: Provides phases for Gnome/Gtk+ based packages.
9# @DESCRIPTION:
8# Exports portage base functions used by ebuilds written for packages using the 10# Exports portage base functions used by ebuilds written for packages using the
9# GNOME framework. 11# GNOME framework. For additional functions, see gnome2-utils.eclass.
10#
11# Maintained by Gentoo's GNOME herd <gnome@gentoo.org>
12#
13 12
13inherit eutils fdo-mime libtool gnome.org gnome2-utils
14 14
15inherit libtool gnome.org debug fdo-mime eutils 15case "${EAPI:-0}" in
16 0|1)
17 EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_preinst pkg_postinst pkg_postrm
18 ;;
19 2|3|4|5)
20 EXPORT_FUNCTIONS src_unpack src_prepare src_configure src_compile src_install pkg_preinst pkg_postinst pkg_postrm
21 ;;
22 *) die "EAPI=${EAPI} is not supported" ;;
23esac
16 24
17 25# @ECLASS-VARIABLE: G2CONF
26# @DEFAULT_UNSET
27# @DESCRIPTION:
18# Extra configure opts passed to econf 28# Extra configure opts passed to econf
19G2CONF=${G2CONF:=""} 29G2CONF=${G2CONF:-""}
20 30
31# @ECLASS-VARIABLE: GNOME2_LA_PUNT
32# @DESCRIPTION:
33# Should we delete ALL the .la files?
34# NOT to be used without due consideration.
35if has ${EAPI:-0} 0 1 2 3 4; then
36 GNOME2_LA_PUNT=${GNOME2_LA_PUNT:-"no"}
37else
38 GNOME2_LA_PUNT=${GNOME2_LA_PUNT:-""}
39fi
40
41# @ECLASS-VARIABLE: ELTCONF
42# @DEFAULT_UNSET
43# @DESCRIPTION:
21# Extra options passed to elibtoolize 44# Extra options passed to elibtoolize
22ELTCONF=${ELTCONF:=""} 45ELTCONF=${ELTCONF:-""}
23 46
47# @ECLASS-VARIABLE: USE_EINSTALL
48# @DEFAULT_UNSET
49# @DESCRIPTION:
24# Should we use EINSTALL instead of DESTDIR 50# Should we use EINSTALL instead of DESTDIR. DEPRECATED
25USE_EINSTALL=${USE_EINSTALL:=""} 51USE_EINSTALL=${USE_EINSTALL:-""}
26 52
27# Run scrollkeeper for this package? 53# @ECLASS-VARIABLE: SCROLLKEEPER_UPDATE
54# @DESCRIPTION:
55# Whether to run scrollkeeper for this package or not. DEPRECATED
28SCROLLKEEPER_UPDATE=${SCROLLKEEPER_UPDATE:="1"} 56SCROLLKEEPER_UPDATE=${SCROLLKEEPER_UPDATE:-"1"}
29 57
30# Directory where scrollkeeper-update should do its work 58# @ECLASS-VARIABLE: DOCS
31SCROLLKEEPER_DIR=${SCROLLKEEPER_DIR:="${ROOT}var/lib/scrollkeeper"} 59# @DEFAULT_UNSET
60# @DESCRIPTION:
61# String containing documents passed to dodoc command.
32 62
33# Path to scrollkeeper-update 63# @ECLASS-VARIABLE: GCONF_DEBUG
34SCROLLKEEPER_UPDATE_BIN=${SCROLLKEEPER_UPDATE_BIN:="${ROOT}usr/bin/scrollkeeper-update"} 64# @DEFAULT_UNSET
65# @DESCRIPTION:
66# Whether to handle debug or not.
67# Some gnome applications support various levels of debugging (yes, no, minimum,
68# etc), but using --disable-debug also removes g_assert which makes debugging
69# harder. This variable should be set to yes for such packages for the eclass
70# to handle it properly. It will enable minimal debug with USE=-debug.
71# Note that this is most commonly found in configure.ac as GNOME_DEBUG_CHECK.
35 72
36# Path to gconftool-2
37GCONFTOOL_BIN=${GCONFTOOL_BIN:="${ROOT}usr/bin/gconftool-2"}
38 73
39if [[ ${GCONF_DEBUG} != "no" ]]; then 74if [[ ${GCONF_DEBUG} != "no" ]]; then
40 IUSE="debug" 75 IUSE="debug"
41fi 76fi
42 77
43DEPEND=">=sys-apps/sed-4"
44 78
79# @FUNCTION: gnome2_src_unpack
80# @DESCRIPTION:
81# Stub function for old EAPI.
45gnome2_src_unpack() { 82gnome2_src_unpack() {
46 unpack ${A} 83 unpack ${A}
47 cd ${S} 84 cd "${S}"
85 has ${EAPI:-0} 0 1 && gnome2_src_prepare
86}
87
88# @FUNCTION: gnome2_src_prepare
89# @DESCRIPTION:
90# Prepare environment for build, fix build of scrollkeeper documentation,
91# run elibtoolize.
92gnome2_src_prepare() {
93 # Prevent assorted access violations and test failures
94 gnome2_environment_reset
48 95
49 # Prevent scrollkeeper access violations 96 # Prevent scrollkeeper access violations
50 gnome2_omf_fix 97 gnome2_omf_fix
51}
52 98
99 # Disable all deprecation warnings
100 gnome2_disable_deprecation_warning
101
102 # Run libtoolize
103 if has ${EAPI:-0} 0 1 2 3; then
104 elibtoolize ${ELTCONF}
105 else
106 # Everything is fatal EAPI 4 onwards
107 nonfatal elibtoolize ${ELTCONF}
108 fi
109
110}
111
112# @FUNCTION: gnome2_src_configure
113# @DESCRIPTION:
114# Gnome specific configure handling
53gnome2_src_configure() { 115gnome2_src_configure() {
54 # Update the GNOME configuration options 116 # Update the GNOME configuration options
55 if [[ ${GCONF_DEBUG} != 'no' ]] ; then 117 if [[ ${GCONF_DEBUG} != 'no' ]] ; then
56 if use debug ; then 118 if use debug ; then
57 G2CONF="${G2CONF} --enable-debug=yes" 119 G2CONF="--enable-debug=yes ${G2CONF}"
58 fi
59 fi 120 fi
121 fi
60 122
61 # Prevent a QA warning 123 # Starting with EAPI=5, we consider packages installing gtk-doc to be
62 if hasq doc ${IUSE} ; then 124 # handled by adding DEPEND="dev-util/gtk-doc-am" which provides tools to
125 # relink URLs in documentation to already installed documentation.
126 # This decision also greatly helps with constantly broken doc generation.
127 # Remember to drop 'doc' USE flag from your package if it was only used to
128 # rebuild docs.
129 # Preserve old behavior for older EAPI.
130 if grep -q "enable-gtk-doc" ${ECONF_SOURCE:-.}/configure ; then
131 if has ${EAPI:-0} 0 1 2 3 4 && has doc ${IUSE} ; then
63 G2CONF="${G2CONF} $(use_enable doc gtk-doc)" 132 G2CONF="$(use_enable doc gtk-doc) ${G2CONF}"
133 else
134 G2CONF="--disable-gtk-doc ${G2CONF}"
64 fi 135 fi
136 fi
65 137
66 # Run libtoolize 138 # Pass --disable-maintainer-mode when needed
67 elibtoolize ${ELTCONF} 139 if grep -q "^[[:space:]]*AM_MAINTAINER_MODE(\[enable\])" \
140 ${ECONF_SOURCE:-.}/configure.*; then
141 G2CONF="--disable-maintainer-mode ${G2CONF}"
142 fi
68 143
69 # Avoid sandbox violations caused by misbehaving packages (bug #128289) 144 # Pass --disable-scrollkeeper when possible
70 addwrite "${ROOT}root/.gnome2" 145 if grep -q "disable-scrollkeeper" ${ECONF_SOURCE:-.}/configure; then
146 G2CONF="--disable-scrollkeeper ${G2CONF}"
147 fi
71 148
72 # GST_REGISTRY is to work around gst-inspect trying to read/write /root 149 # Pass --disable-silent-rules when possible (not needed for eapi5), bug #429308
73 GST_REGISTRY="${S}/registry.xml" econf "$@" ${G2CONF} || die "configure failed" 150 if has ${EAPI:-0} 0 1 2 3 4; then
74} 151 if grep -q "disable-silent-rules" ${ECONF_SOURCE:-.}/configure; then
152 G2CONF="--disable-silent-rules ${G2CONF}"
153 fi
154 fi
75 155
156 # Pass --disable-schemas-install when possible
157 if grep -q "disable-schemas-install" ${ECONF_SOURCE:-.}/configure; then
158 G2CONF="--disable-schemas-install ${G2CONF}"
159 fi
160
161 # Pass --disable-schemas-compile when possible
162 if grep -q "disable-schemas-compile" ${ECONF_SOURCE:-.}/configure; then
163 G2CONF="--disable-schemas-compile ${G2CONF}"
164 fi
165
166 # Avoid sandbox violations caused by gnome-vfs (bug #128289 and #345659)
167 addwrite "$(unset HOME; echo ~)/.gnome2"
168
169 econf ${G2CONF} "$@"
170}
171
172# @FUNCTION: gnome2_src_compile
173# @DESCRIPTION:
174# Stub function for old EAPI.
76gnome2_src_compile() { 175gnome2_src_compile() {
77 gnome2_src_configure "$@" 176 has ${EAPI:-0} 0 1 && gnome2_src_configure "$@"
78 emake || die "compile failure" 177 emake || die "compile failure"
79} 178}
80 179
180# @FUNCTION: gnome2_src_install
181# @DESCRIPTION:
182# Gnome specific install. Handles typical GConf and scrollkeeper setup
183# in packages and removal of .la files if requested
81gnome2_src_install() { 184gnome2_src_install() {
185 has ${EAPI:-0} 0 1 2 && ! use prefix && ED="${D}"
82 # if this is not present, scrollkeeper-update may segfault and 186 # if this is not present, scrollkeeper-update may segfault and
83 # create bogus directories in /var/lib/ 187 # create bogus directories in /var/lib/
84 local sk_tmp_dir="/var/lib/scrollkeeper" 188 local sk_tmp_dir="/var/lib/scrollkeeper"
85 dodir "${sk_tmp_dir}" 189 dodir "${sk_tmp_dir}" || die "dodir failed"
86 190
87 # we must delay gconf schema installation due to sandbox 191 # we must delay gconf schema installation due to sandbox
88 export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL="1" 192 export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL="1"
89 193
90 if [[ -z "${USE_EINSTALL}" || "${USE_EINSTALL}" = "0" ]]; then 194 if [[ -z "${USE_EINSTALL}" || "${USE_EINSTALL}" = "0" ]]; then
91 debug-print "Installing with 'make install'" 195 debug-print "Installing with 'make install'"
92 make DESTDIR=${D} "scrollkeeper_localstate_dir=${D}${sk_tmp_dir} " "$@" install || die "install failed" 196 emake DESTDIR="${D}" "scrollkeeper_localstate_dir=${ED}${sk_tmp_dir} " "$@" install || die "install failed"
93 else 197 else
94 debug-print "Installing with 'einstall'" 198 debug-print "Installing with 'einstall'"
95 einstall "scrollkeeper_localstate_dir=${D}${sk_tmp_dir} " "$@" || die "einstall failed" 199 einstall "scrollkeeper_localstate_dir=${ED}${sk_tmp_dir} " "$@" || die "einstall failed"
96 fi 200 fi
97 201
98 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL 202 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
99 203
204 # Handle documentation as 'default' for eapi5 and newer, bug #373131
205 if has ${EAPI:-0} 0 1 2 3 4; then
100 # Manual document installation 206 # Manual document installation
207 if [[ -n "${DOCS}" ]]; then
208 dodoc ${DOCS} || die "dodoc failed"
209 fi
210 else
211 if ! declare -p DOCS >/dev/null 2>&1 ; then
212 local d
213 for d in README* ChangeLog AUTHORS NEWS TODO CHANGES THANKS BUGS \
214 FAQ CREDITS CHANGELOG ; do
101 [[ -n "${DOCS}" ]] && dodoc ${DOCS} 215 [[ -s "${d}" ]] && dodoc "${d}"
216 done
217 elif declare -p DOCS | grep -q '^declare -a' ; then
218 dodoc "${DOCS[@]}"
219 else
220 dodoc ${DOCS}
221 fi
222 fi
102 223
103 # Do not keep /var/lib/scrollkeeper because: 224 # Do not keep /var/lib/scrollkeeper because:
104 # 1. The scrollkeeper database is regenerated at pkg_postinst() 225 # 1. The scrollkeeper database is regenerated at pkg_postinst()
105 # 2. ${D}/var/lib/scrollkeeper contains only indexes for the current pkg 226 # 2. ${ED}/var/lib/scrollkeeper contains only indexes for the current pkg
106 # thus it makes no sense if pkg_postinst ISN'T run for some reason. 227 # thus it makes no sense if pkg_postinst ISN'T run for some reason.
107 if [[ -z "$(find ${D} -name '*.omf')" ]]; then
108 export SCROLLKEEPER_UPDATE="0"
109 fi
110 rm -rf "${D}${sk_tmp_dir}" 228 rm -rf "${ED}${sk_tmp_dir}"
229 rmdir "${ED}/var/lib" 2>/dev/null
230 rmdir "${ED}/var" 2>/dev/null
111 231
112 # Make sure this one doesn't get in the portage db 232 # Make sure this one doesn't get in the portage db
113 rm -fr "${D}/usr/share/applications/mimeinfo.cache" 233 rm -fr "${ED}/usr/share/applications/mimeinfo.cache"
114}
115 234
116 235 # Delete all .la files
117 236 if has ${EAPI:-0} 0 1 2 3 4; then
118# Applies any schema files installed by the current ebuild to Gconf's database 237 if [[ "${GNOME2_LA_PUNT}" != "no" ]]; then
119# using gconftool-2 238 ebegin "Removing .la files"
120gnome2_gconf_install() { 239 if ! { has static-libs ${IUSE//+} && use static-libs; }; then
121 if [[ ! -x ${GCONFTOOL_BIN} ]]; then 240 find "${D}" -name '*.la' -exec rm -f {} + || die "la file removal failed"
122 return
123 fi
124
125 # We are ready to install the GCONF Scheme now
126 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
127 export GCONF_CONFIG_SOURCE=$(${GCONFTOOL_BIN} --get-default-source)
128
129 einfo "Installing GNOME 2 GConf schemas"
130
131 local contents="${ROOT}/var/db/pkg/*/${PN}-${PVR}/CONTENTS"
132 local F
133
134 for F in $(grep "^obj /etc/gconf/schemas/.\+\.schemas\b" ${contents} | gawk '{print $2}' ); do
135 if [[ -e "${F}" ]]; then
136 # echo "DEBUG::gconf install ${F}"
137 ${GCONFTOOL_BIN} --makefile-install-rule ${F} 1>/dev/null
138 fi
139 done
140
141 # have gconf reload the new schemas
142 ebegin "Reloading GConf schemas"
143 killall -HUP gconfd-2
144 eend $?
145}
146
147# Removes schema files previously installed by the current ebuild from Gconf's
148# database.
149gnome2_gconf_uninstall() {
150 if [[ ! -x ${GCONFTOOL_BIN} ]]; then
151 return
152 fi
153
154 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
155 export GCONF_CONFIG_SOURCE=$(${GCONFTOOL_BIN} --get-default-source)
156
157 einfo "Uninstalling GNOME 2 GConf schemas"
158
159 local contents="${ROOT}/var/db/pkg/*/${PN}-${PVR}/CONTENTS"
160 local F
161
162 for F in $(grep "obj /etc/gconf/schemas" ${contents} | sed 's:obj \([^ ]*\) .*:\1:' ); do
163 # echo "DEBUG::gconf install ${F}"
164 ${GCONFTOOL_BIN} --makefile-uninstall-rule ${F} 1>/dev/null
165 done
166}
167
168# Updates Gtk+ icon cache files under /usr/share/icons if the current ebuild
169# have installed anything under that location.
170gnome2_icon_cache_update() {
171 local updater=$(type -p gtk-update-icon-cache 2> /dev/null)
172
173 if [[ ! -x ${updater} ]] ; then
174 debug-print "${updater} is not executable"
175
176 return
177 fi
178
179 if ! grep -q "obj /usr/share/icons" ${ROOT}/var/db/pkg/*/${PF}/CONTENTS
180 then
181 debug-print "No items to update"
182
183 return
184 fi
185
186 ebegin "Updating icons cache"
187
188 local retval=0
189 local fails=( )
190
191 for dir in $(find ${ROOT}/usr/share/icons -maxdepth 1 -mindepth 1 -type d)
192 do
193 if [[ -f "${dir}/index.theme" ]] ; then
194 local rv=0
195
196 ${updater} -qf ${dir}
197 rv=$?
198
199 if [[ ! $rv -eq 0 ]] ; then
200 debug-print "Updating cache failed on ${dir}"
201
202 # Add to the list of failures
203 fails[$(( ${#fails[@]} + 1 ))]=$dir
204
205 retval=2
206 fi 241 fi
207 fi 242 eend
208 done
209
210 eend ${retval}
211
212 for (( i = 0 ; i < ${#fails[@]} ; i++ )) ; do
213 ### HACK!! This is needed until bash 3.1 is unmasked.
214 ## The current stable version of bash lists the sizeof fails to be 1
215 ## when there are no elements in the list because it is declared local.
216 ## In order to prevent the declaration from being in global scope, we
217 ## this hack to prevent an empty error message being printed for stable
218 ## users. -- compnerd && allanonjl
219 if [[ "${fails[i]}" != "" && "${fails[i]}" != "()" ]] ; then
220 eerror "Failed to update cache with icon ${fails[i]}"
221 fi
222 done
223}
224
225# Workaround applied to Makefile rules in order to remove redundant
226# calls to scrollkeeper-update and sandbox violations.
227gnome2_omf_fix() {
228 local omf_makefiles filename
229
230 omf_makefiles="$@"
231
232 if [[ -f ${S}/omf.make ]] ; then
233 omf_makefiles="${omf_makefiles} ${S}/omf.make"
234 fi 243 fi
235 244 else
236 # testing fixing of all makefiles found 245 case "${GNOME2_LA_PUNT}" in
237 for filename in $(find ./ -name "Makefile.in" -o -name "Makefile.am") ; do 246 yes) prune_libtool_files --modules;;
238 omf_makefiles="${omf_makefiles} ${filename}" 247 no) ;;
239 done 248 *) prune_libtool_files;;
240 249 esac
241 ebegin "Fixing OMF Makefiles"
242
243 local retval=0
244 local fails=( )
245
246 for omf in ${omf_makefiles} ; do
247 local rv=0
248
249 sed -i -e 's:scrollkeeper-update:true:' ${omf}
250 retval=$?
251
252 if [[ ! $rv -eq 0 ]] ; then
253 debug-print "updating of ${omf} failed"
254
255 # Add to the list of failures
256 fails[$(( ${#fails[@]} + 1 ))]=$omf
257
258 retval=2
259 fi 250 fi
260 done
261
262 eend $retval
263
264 for (( i = 0 ; i < ${#fails[@]} ; i++ )) ; do
265 ### HACK!! This is needed until bash 3.1 is unmasked.
266 ## The current stable version of bash lists the sizeof fails to be 1
267 ## when there are no elements in the list because it is declared local.
268 ## In order to prevent the declaration from being in global scope, we
269 ## this hack to prevent an empty error message being printed for stable
270 ## users. -- compnerd && allanonjl
271 if [[ "${fails[i]}" != "" && "${fails[i]}" != "()" ]] ; then
272 eerror "Failed to update OMF Makefile ${fails[i]}"
273 fi
274 done
275} 251}
276 252
277# Updates the scrollkeeper database if necessary. To force this action, make 253# @FUNCTION: gnome2_pkg_preinst
278# sure to set SCROLLKEPER_UPDATE to 1. 254# @DESCRIPTION:
279gnome2_scrollkeeper_update() { 255# Finds Icons, GConf and GSettings schemas for later handling in pkg_postinst
280 if [[ -x ${SCROLLKEEPER_UPDATE_BIN} && "${SCROLLKEEPER_UPDATE}" = "1" ]] 256gnome2_pkg_preinst() {
281 then 257 gnome2_gconf_savelist
282 einfo "Updating scrollkeeper database ..." 258 gnome2_icon_savelist
283 ${SCROLLKEEPER_UPDATE_BIN} -q -p ${SCROLLKEEPER_DIR} 259 gnome2_schemas_savelist
284 fi 260 gnome2_scrollkeeper_savelist
285} 261}
286 262
263# @FUNCTION: gnome2_pkg_postinst
264# @DESCRIPTION:
265# Handle scrollkeeper, GConf, GSettings, Icons, desktop and mime
266# database updates.
287gnome2_pkg_postinst() { 267gnome2_pkg_postinst() {
288 gnome2_gconf_install 268 gnome2_gconf_install
289 gnome2_scrollkeeper_update
290 fdo-mime_desktop_database_update 269 fdo-mime_desktop_database_update
291 fdo-mime_mime_database_update 270 fdo-mime_mime_database_update
292 gnome2_icon_cache_update 271 gnome2_icon_cache_update
272 gnome2_schemas_update
273 gnome2_scrollkeeper_update
293} 274}
294 275
276# # FIXME Handle GConf schemas removal
295#gnome2_pkg_prerm() { 277#gnome2_pkg_prerm() {
296# gnome2_gconf_uninstall 278# gnome2_gconf_uninstall
297#} 279#}
298 280
281# @FUNCTION: gnome2_pkg_postrm
282# @DESCRIPTION:
283# Handle scrollkeeper, GSettings, Icons, desktop and mime database updates.
299gnome2_pkg_postrm() { 284gnome2_pkg_postrm() {
300 gnome2_scrollkeeper_update
301 fdo-mime_desktop_database_update 285 fdo-mime_desktop_database_update
302 fdo-mime_mime_database_update 286 fdo-mime_mime_database_update
303 gnome2_icon_cache_update 287 gnome2_icon_cache_update
288 gnome2_schemas_update
289 gnome2_scrollkeeper_update
304} 290}
305
306EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_postinst pkg_postrm

Legend:
Removed from v.1.77  
changed lines
  Added in v.1.119

  ViewVC Help
Powered by ViewVC 1.1.20